/*
  uupcp j[XRo[gvO	by O.Sasaki 1993.11

  uupc rnews  ۑj[Xf[^EOL CR/LF ɂȂĂ̂
  GNUSňŎזȂ̂ŁAEOLLF݂̂ɃRo[gvOłB

  uupc rnewsύX̂Ԃ̂łAlɂđĂ
  uupc̃o[WႤ̂ŁÂʓ|߁A
  oオăeLXgCR폜悤ɂ܂B

  ̕@̗p̂́AGNUSӊOŃj[Xǂłlɂ́AEOL
  ǂȂĂĂ֌WȂAuupc̃o[WłAj[X
  ǂ߂悤Ȋł΁AGNUSŃj[Xǂ߂悤ɂȂ
  ̗_L܂B

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/utime.h>

#define BUFFER_SIZE 256
#define HEADER_SIZE 2048

typedef struct {
    char *name ;
    char **value ;
} CONFIGDATA ;

char	TmpName[] = "_)news(_.tmp" ;

char	wbuf[HEADER_SIZE] ;	/* ėp[Nobt@			*/
char	nbuf[BUFFER_SIZE] ;	/* VANeBu̓obt@		*/
char	newsdir[BUFFER_SIZE] ;	/* j[XfBNg[		*/
char	newsfile[BUFFER_SIZE] ;	/* j[Xt@C			*/
char	newstmp[BUFFER_SIZE] ;	/* j[Xt@C			*/

char	*UupcConfDir = NULL ;	/* UUPCRtBOfBNg[		*/
char	*UupcNewsDir = NULL ;	/* UUPCj[XfBNg[		*/

struct stat sb ;
struct utimbuf tb ;

CONFIGDATA	Conf[] = {
    { "confdir",	&UupcConfDir		} ,
    { "newsdir",	&UupcNewsDir		} ,
    { NULL, NULL }
} ;

/********************************************************/
/*							*/
/*	UUPCݒǂݎ菈			*/
/*							*/
/*	KvȐݒ荀ڂǂݍ݊eϐɕۑ	*/
/*							*/
/********************************************************/
void GetConfigData( char *rcname )
{
    char	*fname, *pos ;
    FILE	*fp ;
    int		lp, find ;
    char	tmp[BUFFER_SIZE] ;

    fname = getenv( rcname ) ;
    fp = fopen( fname, "r" ) ;
    while ( fgets( tmp, BUFFER_SIZE, fp ) != NULL ) {
	/* Rgs̓XLbv */
	if ( *tmp == '#' )
	    continue ;

	/* 擪̋󔒂AsȂXLbv */
	pos = tmp ;
	while ( isspace( *pos ) ) ++pos ;
	if ( *pos == '\0' )
	    continue ;
	strcpy( wbuf, pos ) ;

	/* I̋󔒂폜 */
	pos = strstr( wbuf, "\n" ) ;
	while ( isspace( *pos ) ) --pos ;
	*(++pos) = '\0' ;

	/* RtBOʎq؂o */
	strcpy( tmp, wbuf ) ;
	if ( ( pos = strstr( tmp, "=" ) ) == NULL )
	    continue ;
	*pos = '\0' ;
	strcpy( wbuf, wbuf + ( pos - tmp ) + 1 ) ;

	/* RtBOʎq */
	for ( pos = tmp ; *pos ; ++pos )
	    *pos = ( char )tolower( *pos ) ;

	lp = find = 0 ;
	while ( Conf[lp].name != NULL ) {
	    if ( strstr( tmp, Conf[lp].name ) == tmp ) {
		find = lp + 1 ;
		break ;
	    }
	    ++lp ;
	}
	if ( !find )
	    continue ;
	--find ;

	if ( *Conf[find].value == NULL ) {
	    *Conf[find].value = malloc( strlen( wbuf ) + 1 ) ;
	} else {
	    *Conf[find].value = realloc( *Conf[find].value,
					strlen( wbuf ) + 1 ) ;
	}
	strcpy( Conf[find].value[0], wbuf ) ;
    }
}

/********************************************************/
/*							*/
/*	UUPCRtBOt@Cpϐ̊J		*/
/*							*/
/********************************************************/
void FreeUupcValue( )
{
    int		lp ;

    lp = 0 ;
    while ( Conf[lp].name != NULL ) {
	if ( *Conf[lp].value != NULL ) {
	    free( *Conf[lp].value ) ;
	}
	++lp ;
    }
}

/********************************************************/
/*							*/
/*		C				*/
/*							*/
/********************************************************/
main( int argc, char *argv[] )
{
    FILE	*new, *old, *in, *out ;
    int		lp, len ;
    int		start, end, dmy ;
    char	*pnt ;


    /* UUPC荞 */
    GetConfigData( "UUPCSYSRC" ) ;
    GetConfigData( "UUPCUSRRC" ) ;

    strcpy( wbuf, UupcConfDir ) ;
    strcat( wbuf, "/active" ) ;
    if ( ( new = fopen( wbuf, "r" ) ) == NULL ) {
	FreeUupcValue( ) ;
	exit( 1 ) ;
    }
    strcpy( wbuf, UupcConfDir ) ;
    strcat( wbuf, "/newsconv" ) ;
    old = fopen( wbuf, "r" ) ;

    while ( fgets( nbuf, BUFFER_SIZE, new ) != NULL ) {
	sscanf( nbuf, "%s %d %d", wbuf, &end, &start ) ;
	for ( pnt = wbuf; *pnt; ++pnt )
	    if ( *pnt == '.' )
		*pnt = '/' ;
	sprintf( newsdir, "%s/%s", UupcNewsDir, wbuf ) ;
	if ( old ) {
	    fgets( nbuf, BUFFER_SIZE, old ) ;
	    sscanf( nbuf, "%s %d", wbuf, &start ) ;
	    ++start ;
	}
	for ( lp = start; lp <= end; ++lp ) {
	    sprintf( newsfile, "%s/%d", newsdir, lp ) ;
	    sprintf( newstmp, "%s.tmp", newsfile ) ;
	    if ( stat( newsfile, &sb ) == -1 )
		continue ;
	    tb.actime  = sb.st_atime ;
	    tb.modtime = sb.st_mtime ;

	    in = fopen( newsfile, "rb" ) ;
	    fgets( wbuf, HEADER_SIZE, in ) ;
	    len = strlen( wbuf ) ;
	    if ( wbuf[len -2] != '\r' ) {
		fclose( in ) ;
		continue ;
	    }
	    out = fopen( newstmp, "wb" ) ;
	    do {
		len = strlen( wbuf ) ;
		if ( wbuf[len -2] == '\r' ) {
		    wbuf[len -2] = '\n' ;
		    wbuf[len -1] = '\0' ;
		}
		fputs( wbuf, out ) ;
	    } while ( fgets( wbuf, HEADER_SIZE, in ) != 0 ) ;
	    fclose( out ) ;
	    fclose( in ) ;

	    strcpy( wbuf, newsfile ) ;
	    strcat( wbuf, ".bak" ) ;
	    if ( rename( newsfile, wbuf ) != -1 ) {
		if ( rename( newstmp, newsfile ) != -1 ) {
		    utime( newsfile, &tb ) ;
		    unlink( wbuf ) ;
		}
	    }
	    printf( "%s...done\n", newsfile ) ;
	}
    }
    fclose( new ) ;
    if ( old )
	fclose( old ) ;

    strcpy( wbuf, UupcConfDir ) ;
    strcat( wbuf, "/active" ) ;
    new = fopen( wbuf, "r" ) ;
    strcpy( wbuf, UupcConfDir ) ;
    strcat( wbuf, "/newsconv" ) ;
    old = fopen( wbuf, "w" ) ;
    while ( fgets( nbuf, BUFFER_SIZE, new ) != NULL )
	fputs( nbuf, old ) ;
    fclose( new ) ;
    fclose( old ) ;
    return 0 ;
}
